<?php

/** Zend_Controller_Plugin_Abstract */
if(!class_exists('Zend_Controller_Plugin_Abstract'))
    require_once 'Zend/Controller/Plugin/Abstract.php';

class ZendExtra_Controller_Plugin_PageCache extends Zend_Controller_Plugin_Abstract
{
    /**
     * Фронт-энд, вызываемый при окончания маршрутизации
     */
    protected $_cacheFrontend = NULL;

    /**
     * Инициализация плагина
     */
    public function __construct(ZendExtra_Cache_Frontend_Page $frontend)
    {
        $this->_cacheFrontend = $frontend;
    }

    /**
     * Запуск страничного кэша.
     * Метод, срабатывающий при завершении маршрутизации, когда маршрут найден.
     * @param Zend_Controller_Request_Abstract $request
     */
    public function routeShutdown(Zend_Controller_Request_Abstract $request)
    {
        $options = Zend_Registry::get('appconfig');
        $cacheManagerOptions = $options['resources']['cachemanager']['options'];
        // Только если нет сессии
        if($cacheManagerOptions['enablePageCache'] == true && !Zend_Session::sessionExists())
            $this->_cacheFrontend->start();
    }
}
